<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/27/2008 *
 * ===================                          Last change: 08/27/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-yoomedia.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Extension for contacting the API of Yoo!Media    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Erweitertung zur Anbindung an die API von        *
 *                     Yoo!Media                                        *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2016 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.0.0');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0'));

// Keep this extension always active!
setExtensionAlwaysActive('Y');

// This extension is deprecated
// @TODO Only deprecated when 'ext-network' is ready: setExtensionDeprecated('Y');

switch (getExtensionMode()) {
	case 'setup': // Do stuff when installation is running
		// SQL commands to run
		addConfigAddSql('yoomedia_id', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
		addConfigAddSql('yoomedia_sid', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
		addConfigAddSql('yoomedia_passwd', "VARCHAR(255) NOT NULL DEFAULT ''");
		addConfigAddSql('yoomedia_erotic_allowed', 'TINYINT(2) UNSIGNED NOT NULL DEFAULT 0' ) ;
		addConfigAddSql('yoomedia_tm_max_reload', 'SMALLINT(6) UNSIGNED NOT NULL DEFAULT ' . (24 * 8));
		addConfigAddSql('yoomedia_tm_min_wait', 'SMALLINT(6) UNSIGNED NOT NULL DEFAULT 60');
		addConfigAddSql('yoomedia_tm_clicks_remain', 'INT(7) UNSIGNED NOT NULL DEFAULT 1000');
		addConfigAddSql('yoomedia_tm_min_pay', 'FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000');
		addConfigAddSql('yoomedia_requests_total', 'SMALLINT(6) UNSIGNED NOT NULL DEFAULT 200');
		addConfigAddSql('yoomedia_requests_remain', 'SMALLINT(6) UNSIGNED NOT NULL DEFAULT 200');

		// Admin menu
		addAdminMenuSql('setup', 'config_yoomedia', 'Yoo!Media Interface 2.0','Einstellungen zum Yoo!Media Interface 2.0, wie Affiliate-Id, Interface-Passwort und vieles mehr.',17);
		addAdminMenuSql('email', 'list_yoomedia_tm', 'Yoo!Media Textmails','Listet Textmail-Buchungen &uuml;ber das Interface 2.0 von Yoo!Media nach Ihren eingestellten Kriterien auf. <strong>Vorsicht:</strong> Jede Aktualisierung dieser Liste kostet Ihnen eine Abfrage!',10);

		// Reload lock table
		addDropTableSql('yoomedia_reload');
		addCreateTableSql('yoomedia_reload', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`type` VARCHAR(255) NOT NULL DEFAULT 'general',
`y_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`y_reload` SMALLINT(6) UNSIGNED NOT NULL DEFAULT 0,
`inserted` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
PRIMARY KEY (`id`),
UNIQUE INDEX `y_type` (`type`, `y_id`)",
			'Reload lock reminder for Yoo!Media campaigns');
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `what` IN('config_yoomedia','list_yoomedia_tm')");
		addDropTableSql('yoomedia_reload');
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql('');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes('');
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		// The translation table
		// @TODO Can this be moved into a database table?
		$GLOBALS['translation_tables']['yoomedia'] = array(
			// Error messages
			'error_codes' => array(
				-999 => 'unknown_error',
				1    => 'wrong_pass',
				2    => 'wrong_sid',
				3    => 'website_locked',
				4    => 'api_data_error',
				5    => 'requests_depleted',
				6    => 'zero_result',
				7    => 'no_campaigns_with_interface',
				10   => 'incomplete_request'
			),
			// For text mails
			'textmail' => array(
				0 => 'id',
				1 => 'name',
				2 => 'reload',
				3 => 'wait',
				4 => 'remain',
				5 => 'pay',
				6 => 'text'
			)
		);
		break;

	default: // Unknown extension mode
		reportBug(__FILE__, __LINE__, sprintf('Unknown extension mode %s in extension %s detected.', getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
